Esx Settings Clusters Vms Transition transition$Task
Transition a System VM Solution desired state to a target cluster. The solution specification is validated before the transition is started.
The operation only initiates the transition. The target desired state is not applied and the solution system VMs remain untouched. A consecutive POST /esx/settings/clusters/{cluster}/vms/solutions?action=apply operation is needed to complete the transition.
Once the operation is completed:
- The desired state for the solution is set to the target cluster.
- The solution can be managed only on the target cluster.
Supported only for solutions with deployment type Esx Settings Clusters Vms DeploymentType.CLUSTER_VM_SET.
This operation was added in vSphere API 9.1.0.0.
Returns an authorization error if you do not have all of the privileges described as follows:
- Operation execution requires
VcIntegrity.systemVM.Write.
Identifier of the target cluster.
The parameter must be an identifier for the resource type: ClusterComputeResource.
Identifier of the solution.
The parameter must be an identifier for the resource type: com.vmware.esx.settings.vms.SystemVmSolution.
Transition specification.
Show optional properties
{
"source_cluster": "string",
"solution": {}
}
{
"source_cluster": "string",
"solution": {
"deployment_type": "string",
"display_name": "string",
"display_version": "string",
"vm_name_template": {
"prefix": "string",
"suffix": "string"
},
"host_solution_spec": {
"prefer_host_configuration": false,
"vm_networks": [
"string"
],
"vm_datastores": [
"string"
]
},
"cluster_solution_spec": {
"vm_count": 0,
"vm_placement_policies": [
"string"
],
"vm_networks": {
"vm_networks": "string"
},
"vm_datastores": [
"string"
],
"devices": {},
"remediation_policy": "string",
"alternative_vm_specs": [
{
"selection_criteria": {
"selection_type": "string",
"extra_config_value": "string"
},
"devices": {}
}
]
},
"hook_configurations": {
"hook_configurations": {
"timeout": 0
}
},
"ovf_resource": {
"location_type": "string",
"url": "string",
"ssl_certificate_validation": "string",
"certificate": "string",
"authentication_scheme": "string"
},
"ovf_descriptor_properties": {
"ovf_descriptor_properties": "string"
},
"vm_clone_config": "string",
"vm_storage_policy": "string",
"vm_storage_profiles": [
"string"
],
"vm_disk_type": "string",
"vm_resource_pool": "string",
"vm_folder": "string",
"vm_resource_spec": {
"ovf_deployment_option": "string"
},
"redeployment_policy": "string"
}
}
Cluster to transition from.
This property was added in vSphere API 9.1.0.0.
When clients pass a value of this schema as a parameter, the property must be an identifier for the resource type: ClusterComputeResource. When operations return a value of this schema as a response, the property will be an identifier for the resource type: ClusterComputeResource.
Target desired solution specification in vLCM.
This property was added in vSphere API 9.1.0.0.
Success!
Vapi Std Errors InvalidArgument If:
- the validation of the cluster desired specification fails.
- the solution associated with solution does not exists in vLCM for sourceCluster property.
- the solution associated with solution already exists in vLCM for the new target cluster associated with cluster.
- the target cluster is not DRS enabled. The value of the data property of Vapi Std Errors Error contains more information. It is a schema that contains all the properties defined in Esx Settings Clusters Vms Transition ValidationResult.
Vapi Std Errors NotAllowedInCurrentState If System VMs are disabled on the cluster via internal ESX Agent Manager (EAM) API (eam.EsxAgentManager#disable).
Vapi Std Errors Unsupported If the cluster associated with cluster is not managed by vLCM.
{
"messages": [
{
"id": "string",
"default_message": "string",
"args": [
"string"
],
"params": {
"params": {
"s": "string",
"dt": "string",
"i": 0,
"d": "number",
"l": {
"id": "string",
"params": {
"params": "Vapi Std LocalizationParam Object"
}
},
"format": "string",
"precision": 0
}
},
"localized": "string"
}
],
"data": {},
"error_type": "string"
}
Stack of one or more localizable messages for human error consumers.
The message at the top of the stack (first in the list) describes the error from the perspective of the operation the client invoked.
Each subsequent message in the stack describes the "cause" of the prior message.
Data to facilitate clients responding to the operation reporting a standard error to indicating that it was unable to complete successfully.
Operations may provide data that clients can use when responding to errors. Since the data that clients need may be specific to the context of the operation reporting the error, different operations that report the same error may provide different data in the error. The documentation for each each operation will describe what, if any, data it provides for each error it reports.
The Vapi Std Errors ArgumentLocations, Vapi Std Errors FileLocations, and Vapi Std Errors TransientIndication schemas are intended as possible values for this property. Vapi Std DynamicID may also be useful as a value for this property (although that is not its primary purpose). Some resources may provide their own specific schemas for use as the value of this property when reporting errors from their operations.
Some operations will not set this property when reporting errors.
Discriminator field to help API consumers identify the structure type.
For more information see: Vapi Std Errors Error Type.
This property was added in vSphere API 6.7.2.
Can be missing or null for compatibility with preceding implementations.
If the caller is not authenticated.
{
"messages": [
{
"id": "string",
"default_message": "string",
"args": [
"string"
],
"params": {
"params": {
"s": "string",
"dt": "string",
"i": 0,
"d": "number",
"l": "Vapi Std NestedLocalizableMessage Object",
"format": "string",
"precision": 0
}
},
"localized": "string"
}
],
"data": {},
"error_type": "string",
"challenge": "string"
}
Indicates the authentication challenges applicable to the target API provider. It can be used by a client to discover the correct authentication scheme to use. The exact syntax of the value is defined by the specific provider, the protocol and authentication schemes used.
For example, a provider using REST may adhere to the WWW-Authenticate HTTP header specification, RFC7235, section 4.1. In this case an example challenge value may be: SIGN realm="27da1358-2ba4-11e9-b210-d663bd873d93",sts="http://vcenter/sso?vsphere.local", Basic realm="vCenter"
This property was added in vSphere API 7.0.0.0.
This property is optional because it was added in a newer version than its parent node.
If the user doesn't have the required privileges.
{
"messages": [
{
"id": "string",
"default_message": "string",
"args": [
"string"
],
"params": {
"params": {
"s": "string",
"dt": "string",
"i": 0,
"d": "number",
"l": "Vapi Std NestedLocalizableMessage Object",
"format": "string",
"precision": 0
}
},
"localized": "string"
}
],
"data": {},
"error_type": "string",
"challenge": "string"
}
Indicates the authentication challenges applicable to the target API provider. It can be used by a client to discover the correct authentication scheme to use. The exact syntax of the value is defined by the specific provider, the protocol and authentication schemes used.
For example, a provider using REST may adhere to the WWW-Authenticate HTTP header specification, RFC7235, section 4.1. In this case an example challenge value may be: SIGN realm="27da158-2ba4-11e9-b",sts="http://vcenter/sso?vsphere.local", Basic realm="vCenter"
This property was added in vSphere API 9.1.0.0.
This property is optional because it was added in a newer version than its parent node.
If there is no cluster associated with the cluster or with the Esx Settings Clusters Vms Transition TransitionSpec.source_cluster part of spec.
{
"messages": [
{
"id": "string",
"default_message": "string",
"args": [
"string"
],
"params": {
"params": {
"s": "string",
"dt": "string",
"i": 0,
"d": "number",
"l": "Vapi Std NestedLocalizableMessage Object",
"format": "string",
"precision": 0
}
},
"localized": "string"
}
],
"data": {},
"error_type": "string"
}
If there is an internal error. The accompanying error message will give more details about the failure.
{
"messages": [
{
"id": "string",
"default_message": "string",
"args": [
"string"
],
"params": {
"params": {
"s": "string",
"dt": "string",
"i": 0,
"d": "number",
"l": "Vapi Std NestedLocalizableMessage Object",
"format": "string",
"precision": 0
}
},
"localized": "string"
}
],
"data": {},
"error_type": "string"
}
Stack of one or more localizable messages for human error consumers.
The message at the top of the stack (first in the list) describes the error from the perspective of the operation the client invoked.
Each subsequent message in the stack describes the "cause" of the prior message.
Data to facilitate clients responding to the operation reporting a standard error to indicating that it was unable to complete successfully.
Operations may provide data that clients can use when responding to errors. Since the data that clients need may be specific to the context of the operation reporting the error, different operations that report the same error may provide different data in the error. The documentation for each each operation will describe what, if any, data it provides for each error it reports.
The Vapi Std Errors ArgumentLocations, Vapi Std Errors FileLocations, and Vapi Std Errors TransientIndication schemas are intended as possible values for this property. Vapi Std DynamicID may also be useful as a value for this property (although that is not its primary purpose). Some resources may provide their own specific schemas for use as the value of this property when reporting errors from their operations.
Some operations will not set this property when reporting errors.
Discriminator field to help API consumers identify the structure type.
For more information see: Vapi Std Errors Error Type.
This property was added in vSphere API 6.7.2.
Can be missing or null for compatibility with preceding implementations.
If the service is not available.
{
"messages": [
{
"id": "string",
"default_message": "string",
"args": [
"string"
],
"params": {
"params": {
"s": "string",
"dt": "string",
"i": 0,
"d": "number",
"l": "Vapi Std NestedLocalizableMessage Object",
"format": "string",
"precision": 0
}
},
"localized": "string"
}
],
"data": {},
"error_type": "string"
}
curl -X POST -H 'Authorization: <value>' -H 'Content-Type: application/json' -d '{"solution":"{}","source_cluster":"string"}' https://{api_host}/api/esx/settings/clusters/{cluster}/vms/transition/{solution}?action=transition&vmw-task=true